<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:java="http://xml.apache.org/xalan/java"
  xmlns:util="ExternalRef" extension-element-prefixes="util">

  <xsl:template match="CrossRef">
    <xsl:variable name="ref" select="@ref"/>
    <xsl:if test="@external">	    	
	    <xsl:variable name="external" select="@external"/>	    
	    <!--<a><xsl:attribute name="href"><xsl:value-of select="java:getRef($util, '@external', '@lang', '@target', '$ref')"/></xsl:attribute></a>-->
	    <a><xsl:attribute name="href"><xsl:value-of select="concat(@external, '_', @lang, '_all.html#', @target, '_', @ref)"/></xsl:attribute><xsl:value-of select="util:getRef($external, @lang, @target, $ref)"/></a>    
	  </xsl:if>
    
  	<a href="#{@target}_{@ref}">
  		<xsl:choose>
  		<xsl:when test="@target='Figure'"><xsl:apply-templates select="//Figure[@id=$ref]" mode="ref"/></xsl:when>
  		<xsl:when test="@target='Table'"><xsl:apply-templates select="//Table[@id=$ref]" mode="ref"/></xsl:when>
  		<xsl:when test="@target='Chapter'"><xsl:apply-templates select="//Chapter[@id=$ref]" mode="ref"/></xsl:when>
  		<xsl:when test="@target='Section'"><xsl:apply-templates select="//Section[@id=$ref]" mode="ref"/></xsl:when> 		
  		<xsl:when test="@target='Subsection'"><xsl:apply-templates select="//Subsection[@id=$ref]" mode="ref"/></xsl:when>
  		</xsl:choose>
  	</a>
  </xsl:template>
  
  <xsl:template match="FootnoteList">  
  <xsl:for-each select="Footnote">
    <a name="fn{@id}"/><a href="#fnref{@id}">[<xsl:value-of select="@id"/>]</a>
    <xsl:apply-templates/>
    <br/>
  </xsl:for-each>
  </xsl:template>
  <xsl:template match="FootnoteRef"><a name="fnref{@id}"/><a href="#fn{@id}">[<xsl:value-of select="@id"/>]</a></xsl:template>
  </xsl:stylesheet>
